=== debian/changelog ===
libmbd (0.12.7-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Sun, 15 Oct 2023 11:06:33 +0200
