=== debian/control ===
Source: libmbd
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               dh-python,
               gfortran,
               libblas-dev,
               liblapack-dev,
               mpi-default-dev,
               python3
Standards-Version: 4.5.1
Homepage: https://github.com/libmbd/libmbd
Vcs-Browser: https://salsa.debian.org/debichem-team/libmbd
Vcs-Git: https://salsa.debian.org/debichem-team/libmbd.git

Package: libmbd-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Many-body dispersion library (development files)
 libMBD implements the many-body dispersion (MBD) method.
 .
 This package contains the static libraries and the header files.
