=== debian/changelog ===
libmbd (0.12.8-2) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 01:27:05 +0100
