=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

-include /usr/share/mpi-default-dev/debian_defaults

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- 					\
		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
		-DBUILD_SHARED_LIBS=NO				\
		-DBUILD_TESTING=YES
