=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s/tarball\/(.*)$/@PACKAGE@-$1.tar.gz/ \
 https://api.github.com/repos/libmbd/@PACKAGE@/releases \
 https://api.github.com/repos/libmbd/@PACKAGE@/tarball/@ANY_VERSION@
